<?php

namespace Diamond\Infrastructure\Models\Domain\Base;

use \Exception;
use \PDO;
use Diamond\Infrastructure\Models\Domain\Domain as ChildDomain;
use Diamond\Infrastructure\Models\Domain\DomainQuery as ChildDomainQuery;
use Diamond\Infrastructure\Models\Domain\Map\DomainTableMap;
use Diamond\Infrastructure\Models\ImageSlider\ImageSlider;
use Diamond\Infrastructure\Models\Menu\Menu;
use Diamond\Infrastructure\Models\Page\Page;
use Diamond\Infrastructure\Models\Promoblock\Promoblock;
use Diamond\Infrastructure\Models\Template\Template;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the '_domains' table.
 *
 *
 *
 * @method     ChildDomainQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildDomainQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method     ChildDomainQuery orderByLang($order = Criteria::ASC) Order by the lang column
 * @method     ChildDomainQuery orderByDomain($order = Criteria::ASC) Order by the domain column
 *
 * @method     ChildDomainQuery groupById() Group by the id column
 * @method     ChildDomainQuery groupByName() Group by the name column
 * @method     ChildDomainQuery groupByLang() Group by the lang column
 * @method     ChildDomainQuery groupByDomain() Group by the domain column
 *
 * @method     ChildDomainQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildDomainQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildDomainQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildDomainQuery leftJoinWith($relation) Adds a LEFT JOIN clause and with to the query
 * @method     ChildDomainQuery rightJoinWith($relation) Adds a RIGHT JOIN clause and with to the query
 * @method     ChildDomainQuery innerJoinWith($relation) Adds a INNER JOIN clause and with to the query
 *
 * @method     ChildDomainQuery leftJoinMenu($relationAlias = null) Adds a LEFT JOIN clause to the query using the Menu relation
 * @method     ChildDomainQuery rightJoinMenu($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Menu relation
 * @method     ChildDomainQuery innerJoinMenu($relationAlias = null) Adds a INNER JOIN clause to the query using the Menu relation
 *
 * @method     ChildDomainQuery joinWithMenu($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Menu relation
 *
 * @method     ChildDomainQuery leftJoinWithMenu() Adds a LEFT JOIN clause and with to the query using the Menu relation
 * @method     ChildDomainQuery rightJoinWithMenu() Adds a RIGHT JOIN clause and with to the query using the Menu relation
 * @method     ChildDomainQuery innerJoinWithMenu() Adds a INNER JOIN clause and with to the query using the Menu relation
 *
 * @method     ChildDomainQuery leftJoinPage($relationAlias = null) Adds a LEFT JOIN clause to the query using the Page relation
 * @method     ChildDomainQuery rightJoinPage($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Page relation
 * @method     ChildDomainQuery innerJoinPage($relationAlias = null) Adds a INNER JOIN clause to the query using the Page relation
 *
 * @method     ChildDomainQuery joinWithPage($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Page relation
 *
 * @method     ChildDomainQuery leftJoinWithPage() Adds a LEFT JOIN clause and with to the query using the Page relation
 * @method     ChildDomainQuery rightJoinWithPage() Adds a RIGHT JOIN clause and with to the query using the Page relation
 * @method     ChildDomainQuery innerJoinWithPage() Adds a INNER JOIN clause and with to the query using the Page relation
 *
 * @method     ChildDomainQuery leftJoinPromoblock($relationAlias = null) Adds a LEFT JOIN clause to the query using the Promoblock relation
 * @method     ChildDomainQuery rightJoinPromoblock($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Promoblock relation
 * @method     ChildDomainQuery innerJoinPromoblock($relationAlias = null) Adds a INNER JOIN clause to the query using the Promoblock relation
 *
 * @method     ChildDomainQuery joinWithPromoblock($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Promoblock relation
 *
 * @method     ChildDomainQuery leftJoinWithPromoblock() Adds a LEFT JOIN clause and with to the query using the Promoblock relation
 * @method     ChildDomainQuery rightJoinWithPromoblock() Adds a RIGHT JOIN clause and with to the query using the Promoblock relation
 * @method     ChildDomainQuery innerJoinWithPromoblock() Adds a INNER JOIN clause and with to the query using the Promoblock relation
 *
 * @method     ChildDomainQuery leftJoinTemplate($relationAlias = null) Adds a LEFT JOIN clause to the query using the Template relation
 * @method     ChildDomainQuery rightJoinTemplate($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Template relation
 * @method     ChildDomainQuery innerJoinTemplate($relationAlias = null) Adds a INNER JOIN clause to the query using the Template relation
 *
 * @method     ChildDomainQuery joinWithTemplate($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Template relation
 *
 * @method     ChildDomainQuery leftJoinWithTemplate() Adds a LEFT JOIN clause and with to the query using the Template relation
 * @method     ChildDomainQuery rightJoinWithTemplate() Adds a RIGHT JOIN clause and with to the query using the Template relation
 * @method     ChildDomainQuery innerJoinWithTemplate() Adds a INNER JOIN clause and with to the query using the Template relation
 *
 * @method     ChildDomainQuery leftJoinImageSlider($relationAlias = null) Adds a LEFT JOIN clause to the query using the ImageSlider relation
 * @method     ChildDomainQuery rightJoinImageSlider($relationAlias = null) Adds a RIGHT JOIN clause to the query using the ImageSlider relation
 * @method     ChildDomainQuery innerJoinImageSlider($relationAlias = null) Adds a INNER JOIN clause to the query using the ImageSlider relation
 *
 * @method     ChildDomainQuery joinWithImageSlider($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the ImageSlider relation
 *
 * @method     ChildDomainQuery leftJoinWithImageSlider() Adds a LEFT JOIN clause and with to the query using the ImageSlider relation
 * @method     ChildDomainQuery rightJoinWithImageSlider() Adds a RIGHT JOIN clause and with to the query using the ImageSlider relation
 * @method     ChildDomainQuery innerJoinWithImageSlider() Adds a INNER JOIN clause and with to the query using the ImageSlider relation
 *
 * @method     \Diamond\Infrastructure\Models\Menu\MenuQuery|\Diamond\Infrastructure\Models\Page\PageQuery|\Diamond\Infrastructure\Models\Promoblock\PromoblockQuery|\Diamond\Infrastructure\Models\Template\TemplateQuery|\Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery endUse() Finalizes a secondary criteria and merges it with its primary Criteria
 *
 * @method     ChildDomain|null findOne(?ConnectionInterface $con = null) Return the first ChildDomain matching the query
 * @method     ChildDomain findOneOrCreate(?ConnectionInterface $con = null) Return the first ChildDomain matching the query, or a new ChildDomain object populated from the query conditions when no match is found
 *
 * @method     ChildDomain|null findOneById(int $id) Return the first ChildDomain filtered by the id column
 * @method     ChildDomain|null findOneByName(string $name) Return the first ChildDomain filtered by the name column
 * @method     ChildDomain|null findOneByLang(string $lang) Return the first ChildDomain filtered by the lang column
 * @method     ChildDomain|null findOneByDomain(string $domain) Return the first ChildDomain filtered by the domain column *

 * @method     ChildDomain requirePk($key, ?ConnectionInterface $con = null) Return the ChildDomain by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildDomain requireOne(?ConnectionInterface $con = null) Return the first ChildDomain matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildDomain requireOneById(int $id) Return the first ChildDomain filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildDomain requireOneByName(string $name) Return the first ChildDomain filtered by the name column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildDomain requireOneByLang(string $lang) Return the first ChildDomain filtered by the lang column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildDomain requireOneByDomain(string $domain) Return the first ChildDomain filtered by the domain column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildDomain[]|Collection find(?ConnectionInterface $con = null) Return ChildDomain objects based on current ModelCriteria
 * @psalm-method Collection&\Traversable<ChildDomain> find(?ConnectionInterface $con = null) Return ChildDomain objects based on current ModelCriteria
 * @method     ChildDomain[]|Collection findById(int $id) Return ChildDomain objects filtered by the id column
 * @psalm-method Collection&\Traversable<ChildDomain> findById(int $id) Return ChildDomain objects filtered by the id column
 * @method     ChildDomain[]|Collection findByName(string $name) Return ChildDomain objects filtered by the name column
 * @psalm-method Collection&\Traversable<ChildDomain> findByName(string $name) Return ChildDomain objects filtered by the name column
 * @method     ChildDomain[]|Collection findByLang(string $lang) Return ChildDomain objects filtered by the lang column
 * @psalm-method Collection&\Traversable<ChildDomain> findByLang(string $lang) Return ChildDomain objects filtered by the lang column
 * @method     ChildDomain[]|Collection findByDomain(string $domain) Return ChildDomain objects filtered by the domain column
 * @psalm-method Collection&\Traversable<ChildDomain> findByDomain(string $domain) Return ChildDomain objects filtered by the domain column
 * @method     ChildDomain[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ?ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 * @psalm-method \Propel\Runtime\Util\PropelModelPager&\Traversable<ChildDomain> paginate($page = 1, $maxPerPage = 10, ?ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class DomainQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Diamond\Infrastructure\Models\Domain\Base\DomainQuery object.
     *
     * @param string $dbName The database name
     * @param string $modelName The phpName of a model, e.g. 'Book'
     * @param string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Diamond\\Infrastructure\\Models\\Domain\\Domain', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildDomainQuery object.
     *
     * @param string $modelAlias The alias of a model in the query
     * @param Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildDomainQuery
     */
    public static function create(?string $modelAlias = null, ?Criteria $criteria = null): Criteria
    {
        if ($criteria instanceof ChildDomainQuery) {
            return $criteria;
        }
        $query = new ChildDomainQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildDomain|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ?ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(DomainTableMap::DATABASE_NAME);
        }

        $this->basePreSelect($con);

        if (
            $this->formatter || $this->modelAlias || $this->with || $this->select
            || $this->selectColumns || $this->asColumns || $this->selectModifiers
            || $this->map || $this->having || $this->joins
        ) {
            return $this->findPkComplex($key, $con);
        }

        if ((null !== ($obj = DomainTableMap::getInstanceFromPool(null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key)))) {
            // the object is already in the instance pool
            return $obj;
        }

        return $this->findPkSimple($key, $con);
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildDomain A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT `id`, `name`, `lang`, `domain` FROM `_domains` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildDomain $obj */
            $obj = new ChildDomain();
            $obj->hydrate($row);
            DomainTableMap::addInstanceToPool($obj, null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con A connection object
     *
     * @return ChildDomain|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param array $keys Primary keys to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return Collection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ?ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param mixed $key Primary key to use for the query
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        $this->addUsingAlias(DomainTableMap::COL_ID, $key, Criteria::EQUAL);

        return $this;
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param array|int $keys The list of primary key to use for the query
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        $this->addUsingAlias(DomainTableMap::COL_ID, $keys, Criteria::IN);

        return $this;
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterById($id = null, ?string $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(DomainTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(DomainTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(DomainTableMap::COL_ID, $id, $comparison);

        return $this;
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%', Criteria::LIKE); // WHERE name LIKE '%fooValue%'
     * $query->filterByName(['foo', 'bar']); // WHERE name IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $name The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByName($name = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(DomainTableMap::COL_NAME, $name, $comparison);

        return $this;
    }

    /**
     * Filter the query on the lang column
     *
     * Example usage:
     * <code>
     * $query->filterByLang('fooValue');   // WHERE lang = 'fooValue'
     * $query->filterByLang('%fooValue%', Criteria::LIKE); // WHERE lang LIKE '%fooValue%'
     * $query->filterByLang(['foo', 'bar']); // WHERE lang IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $lang The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByLang($lang = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($lang)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(DomainTableMap::COL_LANG, $lang, $comparison);

        return $this;
    }

    /**
     * Filter the query on the domain column
     *
     * Example usage:
     * <code>
     * $query->filterByDomain('fooValue');   // WHERE domain = 'fooValue'
     * $query->filterByDomain('%fooValue%', Criteria::LIKE); // WHERE domain LIKE '%fooValue%'
     * $query->filterByDomain(['foo', 'bar']); // WHERE domain IN ('foo', 'bar')
     * </code>
     *
     * @param string|string[] $domain The value to use as filter.
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByDomain($domain = null, ?string $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($domain)) {
                $comparison = Criteria::IN;
            }
        }

        $this->addUsingAlias(DomainTableMap::COL_DOMAIN, $domain, $comparison);

        return $this;
    }

    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\Menu\Menu object
     *
     * @param \Diamond\Infrastructure\Models\Menu\Menu|ObjectCollection $menu the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByMenu($menu, ?string $comparison = null)
    {
        if ($menu instanceof \Diamond\Infrastructure\Models\Menu\Menu) {
            $this
                ->addUsingAlias(DomainTableMap::COL_ID, $menu->getDomainId(), $comparison);

            return $this;
        } elseif ($menu instanceof ObjectCollection) {
            $this
                ->useMenuQuery()
                ->filterByPrimaryKeys($menu->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByMenu() only accepts arguments of type \Diamond\Infrastructure\Models\Menu\Menu or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Menu relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinMenu(?string $relationAlias = null, ?string $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Menu');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Menu');
        }

        return $this;
    }

    /**
     * Use the Menu relation Menu object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\Menu\MenuQuery A secondary query class using the current class as primary query
     */
    public function useMenuQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinMenu($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Menu', '\Diamond\Infrastructure\Models\Menu\MenuQuery');
    }

    /**
     * Use the Menu relation Menu object
     *
     * @param callable(\Diamond\Infrastructure\Models\Menu\MenuQuery):\Diamond\Infrastructure\Models\Menu\MenuQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withMenuQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::INNER_JOIN
    ) {
        $relatedQuery = $this->useMenuQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to Menu table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\Menu\MenuQuery The inner query object of the EXISTS statement
     */
    public function useMenuExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('Menu', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to Menu table for a NOT EXISTS query.
     *
     * @see useMenuExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\Menu\MenuQuery The inner query object of the NOT EXISTS statement
     */
    public function useMenuNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('Menu', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\Page\Page object
     *
     * @param \Diamond\Infrastructure\Models\Page\Page|ObjectCollection $page the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPage($page, ?string $comparison = null)
    {
        if ($page instanceof \Diamond\Infrastructure\Models\Page\Page) {
            $this
                ->addUsingAlias(DomainTableMap::COL_ID, $page->getDomainId(), $comparison);

            return $this;
        } elseif ($page instanceof ObjectCollection) {
            $this
                ->usePageQuery()
                ->filterByPrimaryKeys($page->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByPage() only accepts arguments of type \Diamond\Infrastructure\Models\Page\Page or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Page relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinPage(?string $relationAlias = null, ?string $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Page');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Page');
        }

        return $this;
    }

    /**
     * Use the Page relation Page object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\Page\PageQuery A secondary query class using the current class as primary query
     */
    public function usePageQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinPage($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Page', '\Diamond\Infrastructure\Models\Page\PageQuery');
    }

    /**
     * Use the Page relation Page object
     *
     * @param callable(\Diamond\Infrastructure\Models\Page\PageQuery):\Diamond\Infrastructure\Models\Page\PageQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withPageQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::INNER_JOIN
    ) {
        $relatedQuery = $this->usePageQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to Page table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\Page\PageQuery The inner query object of the EXISTS statement
     */
    public function usePageExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('Page', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to Page table for a NOT EXISTS query.
     *
     * @see usePageExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\Page\PageQuery The inner query object of the NOT EXISTS statement
     */
    public function usePageNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('Page', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\Promoblock\Promoblock object
     *
     * @param \Diamond\Infrastructure\Models\Promoblock\Promoblock|ObjectCollection $promoblock the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByPromoblock($promoblock, ?string $comparison = null)
    {
        if ($promoblock instanceof \Diamond\Infrastructure\Models\Promoblock\Promoblock) {
            $this
                ->addUsingAlias(DomainTableMap::COL_ID, $promoblock->getDomainId(), $comparison);

            return $this;
        } elseif ($promoblock instanceof ObjectCollection) {
            $this
                ->usePromoblockQuery()
                ->filterByPrimaryKeys($promoblock->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByPromoblock() only accepts arguments of type \Diamond\Infrastructure\Models\Promoblock\Promoblock or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Promoblock relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinPromoblock(?string $relationAlias = null, ?string $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Promoblock');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Promoblock');
        }

        return $this;
    }

    /**
     * Use the Promoblock relation Promoblock object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\Promoblock\PromoblockQuery A secondary query class using the current class as primary query
     */
    public function usePromoblockQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinPromoblock($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Promoblock', '\Diamond\Infrastructure\Models\Promoblock\PromoblockQuery');
    }

    /**
     * Use the Promoblock relation Promoblock object
     *
     * @param callable(\Diamond\Infrastructure\Models\Promoblock\PromoblockQuery):\Diamond\Infrastructure\Models\Promoblock\PromoblockQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withPromoblockQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::INNER_JOIN
    ) {
        $relatedQuery = $this->usePromoblockQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to Promoblock table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\Promoblock\PromoblockQuery The inner query object of the EXISTS statement
     */
    public function usePromoblockExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('Promoblock', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to Promoblock table for a NOT EXISTS query.
     *
     * @see usePromoblockExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\Promoblock\PromoblockQuery The inner query object of the NOT EXISTS statement
     */
    public function usePromoblockNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('Promoblock', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\Template\Template object
     *
     * @param \Diamond\Infrastructure\Models\Template\Template|ObjectCollection $template the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByTemplate($template, ?string $comparison = null)
    {
        if ($template instanceof \Diamond\Infrastructure\Models\Template\Template) {
            $this
                ->addUsingAlias(DomainTableMap::COL_ID, $template->getDomainId(), $comparison);

            return $this;
        } elseif ($template instanceof ObjectCollection) {
            $this
                ->useTemplateQuery()
                ->filterByPrimaryKeys($template->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByTemplate() only accepts arguments of type \Diamond\Infrastructure\Models\Template\Template or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Template relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinTemplate(?string $relationAlias = null, ?string $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Template');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Template');
        }

        return $this;
    }

    /**
     * Use the Template relation Template object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\Template\TemplateQuery A secondary query class using the current class as primary query
     */
    public function useTemplateQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinTemplate($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Template', '\Diamond\Infrastructure\Models\Template\TemplateQuery');
    }

    /**
     * Use the Template relation Template object
     *
     * @param callable(\Diamond\Infrastructure\Models\Template\TemplateQuery):\Diamond\Infrastructure\Models\Template\TemplateQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withTemplateQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::INNER_JOIN
    ) {
        $relatedQuery = $this->useTemplateQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to Template table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\Template\TemplateQuery The inner query object of the EXISTS statement
     */
    public function useTemplateExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('Template', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to Template table for a NOT EXISTS query.
     *
     * @see useTemplateExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\Template\TemplateQuery The inner query object of the NOT EXISTS statement
     */
    public function useTemplateNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('Template', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Filter the query by a related \Diamond\Infrastructure\Models\ImageSlider\ImageSlider object
     *
     * @param \Diamond\Infrastructure\Models\ImageSlider\ImageSlider|ObjectCollection $imageSlider the related object to use as filter
     * @param string|null $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this The current query, for fluid interface
     */
    public function filterByImageSlider($imageSlider, ?string $comparison = null)
    {
        if ($imageSlider instanceof \Diamond\Infrastructure\Models\ImageSlider\ImageSlider) {
            $this
                ->addUsingAlias(DomainTableMap::COL_ID, $imageSlider->getDomainId(), $comparison);

            return $this;
        } elseif ($imageSlider instanceof ObjectCollection) {
            $this
                ->useImageSliderQuery()
                ->filterByPrimaryKeys($imageSlider->getPrimaryKeys())
                ->endUse();

            return $this;
        } else {
            throw new PropelException('filterByImageSlider() only accepts arguments of type \Diamond\Infrastructure\Models\ImageSlider\ImageSlider or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the ImageSlider relation
     *
     * @param string|null $relationAlias Optional alias for the relation
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this The current query, for fluid interface
     */
    public function joinImageSlider(?string $relationAlias = null, ?string $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('ImageSlider');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'ImageSlider');
        }

        return $this;
    }

    /**
     * Use the ImageSlider relation ImageSlider object
     *
     * @see useQuery()
     *
     * @param string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery A secondary query class using the current class as primary query
     */
    public function useImageSliderQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinImageSlider($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'ImageSlider', '\Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery');
    }

    /**
     * Use the ImageSlider relation ImageSlider object
     *
     * @param callable(\Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery):\Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery $callable A function working on the related query
     *
     * @param string|null $relationAlias optional alias for the relation
     *
     * @param string|null $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this
     */
    public function withImageSliderQuery(
        callable $callable,
        string $relationAlias = null,
        ?string $joinType = Criteria::LEFT_JOIN
    ) {
        $relatedQuery = $this->useImageSliderQuery(
            $relationAlias,
            $joinType
        );
        $callable($relatedQuery);
        $relatedQuery->endUse();

        return $this;
    }
    /**
     * Use the relation to ImageSlider table for an EXISTS query.
     *
     * @see \Propel\Runtime\ActiveQuery\ModelCriteria::useExistsQuery()
     *
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string $typeOfExists Either ExistsCriterion::TYPE_EXISTS or ExistsCriterion::TYPE_NOT_EXISTS
     *
     * @return \Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery The inner query object of the EXISTS statement
     */
    public function useImageSliderExistsQuery($modelAlias = null, $queryClass = null, $typeOfExists = 'EXISTS')
    {
        return $this->useExistsQuery('ImageSlider', $modelAlias, $queryClass, $typeOfExists);
    }

    /**
     * Use the relation to ImageSlider table for a NOT EXISTS query.
     *
     * @see useImageSliderExistsQuery()
     *
     * @param string|null $modelAlias sets an alias for the nested query
     * @param string|null $queryClass Allows to use a custom query class for the exists query, like ExtendedBookQuery::class
     *
     * @return \Diamond\Infrastructure\Models\ImageSlider\ImageSliderQuery The inner query object of the NOT EXISTS statement
     */
    public function useImageSliderNotExistsQuery($modelAlias = null, $queryClass = null)
    {
        return $this->useExistsQuery('ImageSlider', $modelAlias, $queryClass, 'NOT EXISTS');
    }
    /**
     * Exclude object from result
     *
     * @param ChildDomain $domain Object to remove from the list of results
     *
     * @return $this The current query, for fluid interface
     */
    public function prune($domain = null)
    {
        if ($domain) {
            $this->addUsingAlias(DomainTableMap::COL_ID, $domain->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the _domains table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(?ConnectionInterface $con = null): int
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(DomainTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            DomainTableMap::clearInstancePool();
            DomainTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws \Propel\Runtime\Exception\PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(?ConnectionInterface $con = null): int
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(DomainTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(DomainTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            DomainTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            DomainTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

}
